<?php


class eng_basket_ishop
{
  static protected $_on_set_first=false;
  static protected $name_base_currency="";
  static protected $list_type_pay=[];
  
  function __construct()
    {
      
    }
  
  protected static function _set_first_data()
    {
      if (self::$_on_set_first) return (true);
      
      global $obj_ishop;
      self::$_on_set_first=true;
      
      self::$name_base_currency=$obj_ishop->name_base_currency;
      self::$list_type_pay=$obj_ishop->list_type_pay;
      
      
      return (true);
    }
  
  public static function proc_store($type,$set_basket,$set_promocode)
    {
      $data_basket = array();
      $data_promocode = "";
      
      if ($type == "get")
        {
          if (!empty($_SESSION["ishop_basket"]))
            {
              $data_basket = $_SESSION["ishop_basket"]["product"];
              $data_promocode = $_SESSION["ishop_basket"]["promocode"];
            }
        }
      elseif ($type == "set")
        {
          if (!empty($_SESSION["ishop_basket"]))
            {
              
              if ($set_basket !== false)
                $_SESSION["ishop_basket"]["product"] = $set_basket;
              
              if ($set_promocode !== false)
                $_SESSION["ishop_basket"]["promocode"] = $set_promocode;
            }
          else
            {
              $_SESSION["ishop_basket"] = array("product" => $set_basket, "promocode" => $set_promocode);
            }
        }
      elseif ($type == "clear")
        $_SESSION["ishop_basket"] = false;
      
      return (array($data_basket, $data_promocode));
    }
  
  public static function add_one_num($num_product)
    {
      //возвращает количество товаров в корзине и данные корзины
      list($data_basket, $promocode) = self::proc_store("get", false, false);
      //write_log_cms($data_basket,"data basket");
      
      global $obj_ishop;
      
      list($on_prod_basket, $key_prod_basket) = search_mas_2level($data_basket, "num_product", $num_product, false);
      if ($on_prod_basket)
        {
          // Продукт есть в корзине
          //$data_basket[$key_prod_basket]["quantity"]++;
        }
      else
        {
          $data_basket[] = array("num_product" => $num_product, "quantity" => 1);
          $obj_ishop->add_data_user_behavior("basket_add",["vnum1"=>$num_product]);
        }
      
      self::proc_store("set", $data_basket, false);
      $quantity_basket = sizeof($data_basket);
      
      return (array($quantity_basket, $data_basket, $promocode));
    }
  
  public static function get_data()
    {
      list($data_basket, $promocode) = self::proc_store("get", false, false);
      $quantity_basket = sizeof($data_basket);
      
      return (array($quantity_basket, $data_basket, $promocode));
    }
  
  public static function get_promocode_sdiscount($v_promocode,$service)
    {
      global $obj_ishop;
      
      $one_sdiscount = $obj_ishop->get_one_stng_sdiscount($service);
      //write_log_cms($one_sdiscount,"Данные о скидке");
      
      return ($one_sdiscount);
    }
  
  public static function add_promocode($v_promocode,$service,$data_promocode,$one_sdiscount)
    {
      // Добавляем данные о промокоде в корзину (в сессию)
      list($quantity_basket, $data_basket, $promocode) = self::get_data();
      
      //Если товары есть в корзине, то добавляем промокод
      if ($quantity_basket > 0)
        {
          $data_promocode = array("v_promocode" => $v_promocode,//Текст промокода, к примеру, Скидка5
          "service" => $service,//содержит текст в виде numID_SDISCOUNT
          "one_promocode" => $data_promocode,//массив, данные промокода из базы данных
          "one_sdiscount" => $one_sdiscount//массив, данные о скидке (из массива настроек скидок)
          );
          
          self::proc_store("set", false, $data_promocode);
        }
      
      return (true);
    }
  
  public static function clear_promocode()
    {
       //удаляем из корзины промокод
       self::proc_store("set",false,"");
       return (true);
    }
  
  public static function delete_one_product($num_product)
    {
      //удаляем продукт из корзины
      list($quantity_basket, $data_basket, $data_promocode) = self::get_data();
      
      list($on_search, $key_search) = search_mas_2level($data_basket, "num_product", $num_product, false);
      global $obj_ishop;
      
      if ($on_search)
        {
          unset($data_basket[$key_search]);
          $data_basket = array_values($data_basket);
          self::proc_store("set", $data_basket, false);
          
          $obj_ishop->add_data_user_behavior("basket_del",["vnum1"=>$num_product]);
        }
      
      if (sizeof($data_basket) == 0 && $data_promocode)
        {
          //если товаров в корзине нет, то убираем промокод
          self::clear_promocode();
          
        }
    
      return (true);
    }
  
  public static function calc_data($data_basket,$data_promocode,$on_save_basket=false)
    {
      global $masConfig;
      self::_set_first_data();
      
      $data_comb_basket = [];//$data_basket;
      //write_log_cms($data_basket,"data basket");
      $mas_num_basket = select_mas1lev_2level($data_basket, "num_product", false);
      $kolvo_product = 0;
      $data_product = array();
      
      if (sizeof($mas_num_basket) > 0)
        {
          $db_query = "select id_product, name_product, image, cost, first_cost, name_url, on_request, on_digital, quantity_stock, vendor_code, "
            ."hide, status_product, on_request, on_digital "
            ." from ".DB_PREF."ishop_product product where id_product IN (".implode(",", $mas_num_basket).")"." and hide='show' ";
          list($kolvo_product, $data_product) = db_work::query_select_assoc_index($db_query, "id_product");
        }
      //$this->product_basket=$data_product;
      //$on_save_basket=false;
      $nn = 1;
      $all_cost = 0;
      $calc_cost = 0;
      $sum_discount = 0;
      $on_sum_discount = false;
      $all_digital = true;
      $quantity_basket_not = 0;
      $quantity_basket_is = 0;
      $quantity_basket_cost_not_v = 0;
      $quantity_basket_on_request = 0;
    
      $discount_type = "";
      $discount_size = 0;
    
      $min_sum = 0;
      $on_min_sum = false;
    
      $t_list_prods = "";
    
      $min_sum = floatval($masConfig["MIN_SUM_BASKET_DISCOUNT_ISHOP"]);
      $min_sum = round($min_sum, 2);
    
      $on_incorrect_data_basket = false;
      $incorrect_key_basket = [];
      
      $error_calc=false;
      $error_mas=[];
      
      foreach ($data_basket as $key_elm => $one_elm)
        {
          
          if (!empty($data_product[$one_elm["num_product"]]))
            {
              //$correct_data_basket=$one_elm;
              
              $one_product = $data_product[$one_elm["num_product"]];
              $elm_comb_basket = $one_elm;
              
              $elm_comb_basket["name_product"] = $one_product["name_product"];
              $elm_comb_basket["name_url"] = $one_product["name_url"];
              $elm_comb_basket["on_request"] = $one_product["on_request"];
              $elm_comb_basket["image"] = $one_product["image"];
              $elm_comb_basket["vendor_code"] = $one_product["vendor_code"];
              $elm_comb_basket["hide"] = $one_product["hide"];
              $elm_comb_basket["status_product"] = $one_product["status_product"];
              $elm_comb_basket["on_request"] = $one_product["on_request"];
              $elm_comb_basket["on_digital"] = $one_product["on_digital"];
              
              $image = ($one_product["image"] ? explode("|", $one_product["image"]) : "");
              $elm_comb_basket["name_image"] = $image ? $image[0] : "";
              $elm_comb_basket["first_cost"] = floatval($one_product["first_cost"]);
              //$cost_one=($one_product["discount_cost"] > 0 ? $one_product["discount_cost"]: $one_product["cost"]);
              $cost_one = floatval($one_product["cost"]);
              
              if ($cost_one <= 0)
                {
                  $cost_one = 0;
                  //$this->quantity_basket_cost_not_v++;
                  $quantity_basket_cost_not_v++;
                }
            
              $elm_comb_basket["cost"] = $cost_one;
            
              //Добавляем в данные корзины data_comb_basket максимальное количество товара
              //Если в карточке товара количество больше 0, то указываем это значение
              //Если в карточке товара количество равно 0 и товар доступен под заказ, то указываем максимальное значение рваное 1
              $quantity_stock_product = intval($one_product["quantity_stock"]);
              $elm_comb_basket["max_quantity"] = ($quantity_stock_product > 0 ? $quantity_stock_product : ($one_product["on_request"] == "on" ? 1 : 0));
            
              $quantity_stock_basket = $one_elm["quantity"];
            
              if ($one_product["on_digital"] == "off") $all_digital = false;
            
              if ($quantity_stock_product >= 1 || $one_product["on_request"] == "on")
                {
                  //Товар есть, или он под заказ
                  //$this->quantity_basket_is++;
                  $quantity_basket_is++;
                  if ($one_product["on_request"] == "on") //$this->quantity_basket_on_request++;
                    $quantity_basket_on_request++;
                
                  if ($quantity_stock_basket > $quantity_stock_product)
                    {
                      //Количество товара, указанного в заказе (в корзине), больше чем указано в карточке товара
                      if ($quantity_stock_product >= 1)
                        {
                          $quantity_stock_basket = $quantity_stock_product;
                          $on_save_basket = true;
                          $data_basket[$key_elm]["quantity"] = $quantity_stock_basket;
                          $elm_comb_basket["quantity"] = $quantity_stock_basket;
                        }
                      else
                        {
                          //Количество товара в карточке равно 0 и товар доступен под заказ
                          //поэтому не меняем ничего в заказе
                        }
                    }
                  else
                    {
                      //товар в заказе (в корзине) равен нулю (по какой-либо причине), когда в карточке товара больше 0
                      if ($quantity_stock_basket <= 0)
                        {
                          $quantity_stock_basket = 1;
                          $on_save_basket = true;
                          $data_basket[$key_elm]["quantity"] = $quantity_stock_basket;
                          $elm_comb_basket["quantity"] = $quantity_stock_basket;
                        }
                    }
                }
              else
                {
                  //Товара нет и под заказ не доступен
                  //$this->quantity_basket_not++;
                  $quantity_basket_not++;
                  if ($quantity_stock_basket != 0)
                    {
                      $quantity_stock_basket = 0;
                      $on_save_basket = true;
                      $data_basket[$key_elm]["quantity"] = 0;
                      $elm_comb_basket["quantity"] = 0;
                    }
                }
            
              $cost_quantity = $cost_one * $quantity_stock_basket;
              $elm_comb_basket["cost_quantity"] = $cost_quantity;
              $all_cost += $cost_quantity;
              
              $t_list_prods .= $nn.". ".codeHtmlText($one_product["name_product"]);
              $t_list_prods .= "<br/>"."ID-".$one_product["id_product"].","
                ." количество: ".$quantity_stock_basket
                .", стоимость: ".$cost_one."/".$cost_quantity
                ." ".self::$name_base_currency."<br/>";
              
              $nn++;
              
              $data_comb_basket[] = $elm_comb_basket;
            }
          else
            {
              //в базе не найден товар, находящийся в корзине
              //нужно будет удалить этот товар из корзины
              
              $on_incorrect_data_basket = true;
              $incorrect_key_basket[] = $key_elm;
            }
          
        }
      
      if ($on_incorrect_data_basket)
        {
          $error_calc=true;
          foreach ($incorrect_key_basket as $one_num)
            {
              unset($data_basket[$one_num]);
            }
          $data_basket = array_values($data_basket);
          $on_save_basket = true;
        }
      
      $calc_cost = $all_cost;
      
      if ($all_cost > 0 && $data_promocode && $data_promocode["one_sdiscount"])
        {
          //write_log_cms($data_promocode,"данные промокода. calc basket");
          $one_sdiscount = $data_promocode["one_sdiscount"];
          
          if ($one_sdiscount["type"] == "percent")
            {
              $sum_discount = $calc_cost * $one_sdiscount["size"] / 100;
              $calc_cost -= $sum_discount;
              $on_sum_discount = true;
              $discount_type = $one_sdiscount["type"];
              $discount_size = $one_sdiscount["size"];
            }
          elseif ($one_sdiscount["type"] == "amount")
            {
              $sum_discount = $one_sdiscount["size"];
              $calc_cost -= $sum_discount;
              $on_sum_discount = true;
              $discount_type = $one_sdiscount["type"];
              $discount_size = $one_sdiscount["size"];
            }
          
          if ($calc_cost <= $min_sum)
            {
              $calc_cost = $min_sum;
              $on_min_sum = true;
            }
        }
      
      if ($on_save_basket)
        {
          //write_log_cms($data_basket,"resave basket");
          self::proc_store("set", $data_basket, false);
        }
      
      //write_log_cms($data_comb_basket,"data_comb_basket");
      
      return (array(
        "data_basket"=>$data_basket,
        "data_comb_basket"=>$data_comb_basket,
        "data_product"=>$data_product,
        "all_cost"=>$all_cost,
        "calc_cost"=>$calc_cost,
        "sum_discount"=>$sum_discount,
        "on_sum_discount"=>$on_sum_discount,
        "all_digital"=>$all_digital,
        "quantity_basket_not"=>$quantity_basket_not,
        "quantity_basket_is"=>$quantity_basket_is,
        "quantity_basket_cost_not_v"=>$quantity_basket_cost_not_v,
        "quantity_basket_on_request"=>$quantity_basket_on_request,
        "discount_type"=>$discount_type,
        "discount_size"=>$discount_size,
        "min_sum"=>$min_sum,
        "on_min_sum"=>$on_min_sum,
        "t_list_prods"=>$t_list_prods,
        "on_save_basket"=>$on_save_basket,
        "error_calc"=>$error_calc,
        
       ));
    }
  
  public static function create_order($d_calc,$data_promocode,$data_order_user,$data_registr_user)
    {
      global $infoUserAgent, $dir_http;
      
      self::_set_first_data();
      
      //write_log_cms($d_calc,"d_calc create order");
      $data_basket = $d_calc["data_basket"];
      $data_comb_basket = $d_calc["data_comb_basket"];
      $data_product = $d_calc["data_product"];
      $all_cost = $d_calc["all_cost"];
      $calc_cost = $d_calc["calc_cost"];
      $sum_discount = $d_calc["sum_discount"];
      $on_sum_discount = $d_calc["on_sum_discount"];
      $all_digital = $d_calc["all_digital"];
      $quantity_basket_not = $d_calc["quantity_basket_not"];
      $quantity_basket_is = $d_calc["quantity_basket_is"];
      $quantity_basket_cost_not_v = $d_calc["quantity_basket_cost_not_v"];
      $quantity_basket_on_request = $d_calc["quantity_basket_on_request"];
      $discount_type = $d_calc["discount_type"];
      $discount_size = $d_calc["discount_size"];
      
      $t_list_prods = $d_calc["t_list_prods"];
      $on_save_basket = $d_calc["on_save_basket"];
      
      $quantity_basket = sizeof($data_basket);
      
      $error_data = false;
      $check_order_error = false;
      $check_order_text_error = "";
      $check_order_mas_error = array();
      
      $data_form = array(
        "name_user" => "",
        "phone_user" => "",
        "email_user" => $GLOBALS["email_user_to_site"],
        "address_user" => "",
        "comment_user" => "",
        "type_pay" => "",
        "delivery_method" => "delivery"
      );
      
      $num_order = 0;
      
      if ($data_order_user && $data_order_user["id_user"] && $quantity_basket > 0 && $quantity_basket_is > 0 && !$d_calc["error_calc"] && !($d_calc["quantity_basket_not"] > 0 || $d_calc["quantity_basket_cost_not_v"] > 0) )//$GLOBALS["user_to_site"]
        /*&& !empty( $_POST["act_check_order"] ) && $_POST["act_check_order"] == "on"*/
        {
          
          $mas_init = array(
            //array("name_user", "post", "name_user", "text", true, true, false, false, true, "tr", false, false, "Укажите свое имя и отчество!", true, true),
            //array("phone_user", "post", "phone_user", "text", true, true, false, false, true, "tr", false, false, "Укажите свой телефон!", true, true),
            //array("email_user", "post", "email_user", "text", false, false, false, false, true, "tr", false, false, "Укажите свой Email!", true, true),
            array("delivery_method", "post", "delivery_method", "text", true, true, "listv", "delivery,pickup", true, "tr", "all", "", "Укажите способ доставки товара!", true, true),
            array("address_user", "post", "address_user", "text", true, false, false, false, true, "tr", "all", "", "Укажите адрес доставки товара!", true, true),
            array("comment_user", "post", "comment_user", "text", true, false, false, false, true, "tr", "all", "", false, false, false),
            array("type_pay", "post", "type_pay", "numeric", true, true, false, false, false, false, false, false, "Выберите способ оплаты!", true, true),
            //array("on_rules_site", "post", "on_rules_site", "text", true, true, "value", "on", true, "tr", "all", "", "Нужно согласиться с правилами сайта и с обработкой персональных данных!", true, true),
            array("contr_code", "post", "contr_code", "text", true, true, false, "", false, false, false, false, "Не указан ключ безопасности!", true, false)
          );
          
          global $obj_control_data;
          
          $set_init = $obj_control_data->processing_one_group($mas_init);
          
          $on_check_contr = false;
          
          $mas_inbox = $set_init[3];
          $status_inbox = $set_init[5];
          
          if ($set_init[0] && !$set_init[1])
            {
              
              if (eng_promote_safety::check_code($GLOBALS["id_user_to_site"], $mas_inbox["contr_code"]))
                {
                  $on_check_contr = true;
                }
              else
                {
                  $check_order_error = true;
                  $check_order_text_error = "Неверный ключ безопасности!";
                
                  $data_form = $set_init[3];
                  $error_data = true;
                }
            }
          else
            {
              $check_order_error = true;
              $check_order_mas_error = $set_init[4];
              
              $data_form = $set_init[3];
              $error_data = true;
            }
        
          if (!$error_data)
            {
              //проверяем, указан адрес или нет
              if (!$all_digital)
                {
                  if ($mas_inbox["delivery_method"] != "pickup" && $mas_inbox["address_user"] == "")
                    {
                      $check_order_error = true;
                      $check_order_mas_error[] = "Не указан адрес доставки товара!";
                      
                      $error_data = true;
                    }
                }
            }
          
          if (!$error_data)
            {
              
              global $ishop_first_type_order;
              
              $mas_index = array(/*"name_user", "email_user", "phone_user",*/ "delivery_method", "address_user", "comment_user", "type_pay");
              $mas_save = copy_mas_to_mas_index($mas_inbox, array(), $mas_index);
              
              $mas_save["name_user"]=$data_order_user["name_user"];
              $mas_save["email_user"]=$data_order_user["email_user"];
              $mas_save["phone_user"]=$data_order_user["phone_user"];
              //$list_products = serialize($mas_products_basket);
              
              $v_promocode = "";
              $one_promocode = false;
              
              if ($data_promocode)
                {
                  $v_promocode = $data_promocode["v_promocode"];
                  $one_promocode = $data_promocode["one_promocode"];
                }
              
              $mas_save["id_order"] = 0;
              $mas_save["type"] = $ishop_first_type_order;
              $mas_save["putdate"] = $GLOBALS["timeGlobal"];
              
              $mas_save["list_product"] = "";
              $mas_save["status"] = "notpaid";
              $mas_save["num_user"] = $data_order_user["id_user"];// $GLOBALS["id_user_to_site"];
              $mas_save["all_cost"] = $all_cost;
              $mas_save["pay_date"] = 0;
              $mas_save["comment_order"] = "";
              $mas_save["discount_percent"] = (($on_sum_discount && $discount_type == "percent") ? $discount_size : 0);
              $mas_save["discount_sum"] = $sum_discount;
              //$mas_save["special_cost"] = 0;
              //$mas_save["type_pay"] = 0;
              $mas_save["amount_paid"] = $calc_cost;
              
              $mas_save["ip_adr"] = $infoUserAgent[1];
              $mas_save["dop_info"] = $infoUserAgent[0];
              
              $mas_save["promocode"] = $v_promocode;
              
              $db_query = forming_db_query_indexmas(DB_PREF."ishop_order", $mas_save, "insert", "id_order");
              
              $q_ident = db_work::query($db_query);
              
              $num_order = db_work::get_insert_id();
              
              $db_query = "insert into ".DB_PREF."ishop_order_item values ";
              $raz = "";
              
              // таблица ishop_order_item
              // id_item, num_order, num_product, cost_product, quantity
              
              $mas_insert = array();
              foreach ($data_comb_basket as $one_row)
                {
                  if ($one_row["quantity"] < 1) continue;
                  
                  $mas_insert[] = array(
                    "id_item" => 0,
                    "num_order" => $num_order,
                    "num_product" => $one_row["num_product"],
                    "cost_product" => $one_row["cost"],
                    "quantity" => $one_row["quantity"]
                  );
                  //$db_query .= $raz . "(0,".$num_order.",".$one_row["num_product"].",".$one_row["cost"].",".$one_row["quantity"].")";
                  //$raz=",";
                }
              
              if (sizeof($mas_insert) > 0)
                {
                  $db_query = forming_db_query_insert_many_row(DB_PREF."ishop_order_item", $mas_insert);
                  $q_ident = db_work::query($db_query);
                }
              
              
              //Если указан промокод, то добавляем количество использований промокоду
              if ($one_promocode)
                {
                  $obj_proc_promocode = new classProcPromocode();
                  $obj_proc_promocode->promocode_data_use_incr($one_promocode);
                }
              
              //Добавляем данные в статистику действий пользователя
              global $obj_ishop;
              $obj_ishop->add_data_user_behavior("crt_order",["vnum2"=>$num_order,"num_user"=>$data_order_user["id_user"]]);
              
              // Отправляем уведомление администратору сайта
              
              $subject = "Оповещение о новом заказе!";
              
              $message=self::_forming_message_admin($mas_inbox,$data_order_user,$data_registr_user,$quantity_basket,$d_calc,$num_order,$v_promocode,$t_list_prods);
              
              @send_email($subject, $message, "Администрация сайта", EMAIL_ADMIN);
              
              self::proc_store("clear", false, false);
              
              
              // Отправляем письмо заказчику
              
              if ($data_order_user["email_user"])
                {
                  $subject="Заказ принят";
                  
                  $message=self::_forming_message_user($mas_inbox,$data_order_user,$quantity_basket,$d_calc,$num_order,$v_promocode);
                  
                  @send_email($subject, $message, "", $data_order_user["email_user"],false,false,false,false,true);
                  
                }
              
            }
          
        }
      else
        {
          $error_data=true;
          $check_order_error = true;
          $check_order_text_error = "Ошибка с данными заказа!";
        }
      
      $rez=array(
        "error_data"=>$error_data,
        "check_order_error"=>$check_order_error,
        "check_order_text_error"=>$check_order_text_error,
        "check_order_mas_error"=>$check_order_mas_error,
        "data_form"=>$data_form,
        "num_order"=>$num_order,
       );
      
      return ($rez);
    }
  
  static protected function _forming_message_admin($data_order, $data_order_user, $data_registr_user, $quantity_basket, $d_calc, $num_order, $v_promocode, $t_list_prods)
    {
      global $dir_http;
      
      //$data_basket = $d_calc["data_basket"];
      $data_comb_basket = $d_calc["data_comb_basket"];
      /*
      //write_log_cms($d_calc,"d_calc");
      //write_log_cms($data_basket,"data_basket");
      //write_log_cms($data_comb_basket,"data_comb_basket");
      */
      $all_cost = $d_calc["all_cost"];
      $on_sum_discount = $d_calc["on_sum_discount"];
      $discount_type = $d_calc["discount_type"];
      $discount_size = $d_calc["discount_size"];
      $sum_discount = $d_calc["sum_discount"];
      $calc_cost = $d_calc["calc_cost"];
      $all_digital = $d_calc["all_digital"];
      
      $t_list_prods2="";
      
      $n=1;
      $sep="";
      $name_cur = self::$name_base_currency;
      
      foreach ($data_comb_basket as $one_item)
        {
          $t_one = $n.". <strong>". codeHtmlText($one_item["name_product"])."</strong>";
          $t_one .= "<br />\n";
          $t_one .= "ID - ". $one_item["num_product"] .", ";
          $t_one .= $one_item["cost"] ." ".$name_cur .", кол-во ".$one_item["quantity"]." шт, всего ".$one_item["cost_quantity"]." ". $name_cur;
          $t_list_prods2 .= $sep . $t_one;
          $sep = "<br />\n<br />\n";
          $n++;
        }
      
      // Текст письма администратору
      $msg = 'Здравствуйте!<br /><br />На вашем сайте '
        ."http://".$_SERVER["SERVER_NAME"].$dir_http." был сформирован новый заказ.<br/>\n<br/>\n"
        ." Номер заказа: ".$num_order.". <br />\n<br />\n"
        ."Данные пользователя:<br />\n"
        
        ."ID пользователя: ".$data_registr_user["id_user"]."<br />\n"
        ."Логин: ".codeHtmlText($data_registr_user["name_user"])."<br />\n"
        ."Email пользователя: ".codeHtmlText($data_registr_user["email_user"])."<br />\n<br />\n"
        
        ."Товаров в заказе: ".$quantity_basket."<br />\n"
        ."Товары:"."<br />\n<br />\n"
        .$t_list_prods2."<br />\n<br />\n"
        
        ."<strong>Сумма заказа:</strong> ".$all_cost." ".self::$name_base_currency."<br />\n"
        ."Промокод: ".($v_promocode ? $v_promocode : "нет")."<br />\n"
        ."Скидка: ".($on_sum_discount ? ($discount_type == "percent" ? $discount_size."% - " : "").$sum_discount." ".self::$name_base_currency : "нет")."<br />\n<br />\n"
        
        ."<strong>СУММА К ОПЛАТЕ:</strong> ".$calc_cost." ".self::$name_base_currency."<br />\n<br />\n"
        
        ."ДАННЫЕ ФОРМЫ ЗАКАЗА:<br />\n<br />\n"
        ."ФИО: ".codeHtmlText($data_order_user["name_user"])."<br />\n"
        ."Телефон: ".codeHtmlText($data_order_user["phone_user"])."<br />\n"
        ."E-mail: ".($data_order_user["email_user"] ? codeHtmlText($data_order_user["email_user"]) : "нет")."<br />\n"
        ."Способ доставки: ".($all_digital ? "Доставка не требуется (только цифровые товары)" : ($data_order["delivery_method"] == "pickup" ? "Самовывоз" : "Доставка"))."<br />\n"
        ."Адрес доставки: ".codeHtmlText($data_order["address_user"])."<br />\n"
        ."Комментарий: ".(trim($data_order["comment_user"]) ? codeHtmlText($data_order["comment_user"]) : "нет")."<br /><br />\n"
        ."Способ оплаты: ".(isset(self::$list_type_pay[$data_order["type_pay"]]) ? self::$list_type_pay[$data_order["type_pay"]] : "нет данных")."<br />\n";
      
      $msg .= forming_signature_email();
    
      return ($msg);
    }
  
  static protected function _forming_message_user($data_order, $data_user, $quantity_basket, $d_calc, $num_order, $v_promocode)
    {
      global $dir_http;
      
      //$data_basket = $d_calc["data_basket"];
      $data_comb_basket = $d_calc["data_comb_basket"];
      /*
      write_log_cms($d_calc,"d_calc");
      write_log_cms($data_basket,"data_basket");
      write_log_cms($data_comb_basket,"data_comb_basket");
      */
      $all_cost = $d_calc["all_cost"];
      $on_sum_discount = $d_calc["on_sum_discount"];
      $discount_type = $d_calc["discount_type"];
      $discount_size = $d_calc["discount_size"];
      $sum_discount = $d_calc["sum_discount"];
      $calc_cost = $d_calc["calc_cost"];
      $all_digital = $d_calc["all_digital"];
      
      $t_list_prods2="";
      
      $n=1;
      $sep="";
      $name_cur = self::$name_base_currency;
      
      foreach ($data_comb_basket as $one_item)
        {
          $t_one = $n.". <strong>". codeHtmlText($one_item["name_product"])."</strong>";
          $t_one .= "<br />\n";
          //$t_one .= "ID - ". $one_item["num_product"] .", ";
          $t_one .= "Стоимость ". $one_item["cost"] ." ".$name_cur .", кол-во ".$one_item["quantity"]." шт, всего ".$one_item["cost_quantity"]." ". $name_cur;
          $t_list_prods2 .= $sep . $t_one;
          $sep = "<br />\n<br />\n";
          $n++;
        }
      
      // Текст письма пользователю
      $msg = "Здравствуйте!<br />\n<br />\n"
        ."ВАШ ЗАКАЗ ПРИНЯТ. <br />\n<br />\n"
        
        ."Номер заказа: ".$num_order."<br/>\n<br/>\n"
        
        ."Мы уже занимаемся вашим заказом.<br />\n<br />\n"
        
        ."Товаров в заказе: ".$quantity_basket."<br />\n"
        ."Товары:"."<br />\n<br />\n"
        .$t_list_prods2."<br />\n<br />\n"
        
        ."<strong>Сумма заказа:</strong> ".$all_cost." ".self::$name_base_currency."<br />\n"
        ."Промокод: ".($v_promocode ? $v_promocode : "нет")."<br />\n"
        ."Скидка: ".($on_sum_discount ? ($discount_type == "percent" ? $discount_size."% - " : "").$sum_discount." ".self::$name_base_currency : "нет")."<br />\n<br />\n"
        
        ."<strong>СУММА К ОПЛАТЕ:</strong> ".$calc_cost." ".self::$name_base_currency."<br />\n<br />\n"
        
        ."Данные, которые вы указали при оформлении заказа:<br />\n"
        //."ФИО: ".codeHtmlText($data_user["name_user"])."<br />\n"
        //."Телефон: ".codeHtmlText($data_user["phone_user"])."<br />\n"
        //."E-mail: ".($data_user["email_user"] ? codeHtmlText($data_user["email_user"]) : "нет")."<br />\n"
        . (!$all_digital ? "Способ доставки: ". ($data_order["delivery_method"] == "pickup" ? "Самовывоз" : "Доставка") ."<br />\n" : "")
        ."Адрес доставки: ".(trim($data_order["address_user"]) ? codeHtmlText($data_order["address_user"]) : "не указан" )."<br />\n"
        ."Комментарий: ".(trim($data_order["comment_user"]) ? codeHtmlText($data_order["comment_user"]) : "не указан")."<br /><br />\n"
        ."Способ оплаты: ".(isset(self::$list_type_pay[$data_order["type_pay"]]) ? self::$list_type_pay[$data_order["type_pay"]] : "не указан")."<br />\n";
      
      $msg .= forming_signature_email();
      
      return ($msg);
    }
  
  
}
